#pragma once

#include "sdkexport.h"
#include "RobJoint.h"
#include "ExtJoint.h"
#include <string>

namespace mpl {

namespace sdk {
class TypeConversions;
}

class MPL_API JointTarget {
public:
    JointTarget() = delete;
    ~JointTarget();
    
    JointTarget(const JointTarget&) = default;
    JointTarget& operator=(const JointTarget&) = default;
    JointTarget(JointTarget&&) = default;
    JointTarget& operator=(JointTarget&&) = default;

    unsigned getId() const;
    std::string getName() const;

    RobJoint getRobJoint() const;
    ExtJoint getExtJoint() const;

    std::string toString() const;

private:
    friend class sdk::TypeConversions;

    explicit JointTarget(const void* impl);

    const void* pimpl;
};

}
